/*
 * CH423.c
 *
 *  Created on: 20231024
 *      Author: Administrator
 */

#include "sys.h"

u8 CH423_buf[16];    //16ܵӳ󻺴
const u8 BCD_decode_tab[0x10] = { 0X3F, 0X06, 0X5B, 0X4F, 0X66, 0X6D,
        0X7D, 0X07, 0X7F, 0X6F, 0X77, 0X7C, 0X58, 0X5E, 0X79, 0X71 };

void CH423_SCL_D_OUT(void)
 { // SCLΪ,˫I/OлΪ
    GPIO_InitTypeDef GPIO_InitStructure = { 0 };

    GPIO_InitStructure.GPIO_Pin = SMG_SCL_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(SMG_SCL_GPIO_Port, &GPIO_InitStructure);
}
void CH423_SDA_D_OUT(void)
 { // SDAΪ,˫I/OлΪ
    GPIO_InitTypeDef GPIO_InitStructure = { 0 };

    GPIO_InitStructure.GPIO_Pin = SMG_SDA_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(SMG_SDA_GPIO_Port, &GPIO_InitStructure);
}
void CH423_SDA_D_IN(void)
 { // SDAΪ뷽,˫I/OлΪ
    GPIO_InitTypeDef GPIO_InitStructure = { 0 };

    GPIO_InitStructure.GPIO_Pin = SMG_SDA_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init(SMG_SDA_GPIO_Port, &GPIO_InitStructure);
}

void CH423_I2c_Start(void) // ʼ
{
    CH423_SDA_SET; // ʼź
    CH423_SDA_D_OUT(); // SDAΪ
    CH423_SCL_SET;
    CH423_SCL_D_OUT(); // SCLΪ
    DELAY_0_1US;
    CH423_SDA_CLR; //ʼź
    DELAY_0_1US;
    CH423_SCL_CLR; //ǯסI2Cߣ׼ͻ
}

void CH423_I2c_Stop(void) // 
{
    CH423_SDA_CLR;
    DELAY_0_1US;
    CH423_SCL_SET;
    DELAY_0_1US;
    CH423_SDA_SET; // I2C߽ź
    DELAY_0_1US;
}

void CH423_I2c_WrByte(u8 dat) // дһֽ
{
	u8 i;
	for(i=0;i!=8;i++) // 8λ
	{
		if(dat&0x80)
		{
            CH423_SDA_SET;
		}else
		{
            CH423_SDA_CLR;
		}
        DELAY_0_1US;
        CH423_SCL_SET;
		dat<<=1;
        DELAY_0_1US; // ѡʱ
        CH423_SCL_CLR;
	}
    CH423_SDA_SET;
    DELAY_0_1US;
    CH423_SCL_SET; // Ӧ
    DELAY_0_1US;
    CH423_SCL_CLR;
}

u8 CH423_I2c_RdByte(void) // һֽ
{
	u8 dat, i;
    CH423_SDA_SET;
    CH423_SDA_D_IN(); // SDAΪ뷽
	dat=0;
	for(i=0;i!=8;i++) // 8λ
	{
        DELAY_0_1US; // ѡʱ
        CH423_SCL_SET;
        DELAY_0_1US; // ѡʱ
		dat<<=1;
		if(CH423_SDA_IN)
			dat++; // 1λ
        CH423_SCL_CLR;
	}
    CH423_SDA_SET;
    DELAY_0_1US;
    CH423_SCL_SET; // ЧӦ
    DELAY_0_1US;
    CH423_SCL_CLR;
	return (dat);
}

void CH423_Write(u16 cmd) // д
{
	CH423_I2c_Start(); // 
	CH423_I2c_WrByte(((u8) (cmd >> 7) & CH423_I2C_MASK) | CH423_I2C_ADDR1);
	CH423_I2c_WrByte((u8) cmd); // 
	CH423_I2c_Stop(); // 
}

void CH423_WriteByte(u16 cmd) // д
{
	CH423_I2c_Start(); // 
	CH423_I2c_WrByte((u8) (cmd >> 8));
	CH423_I2c_WrByte((u8) cmd); // 
	CH423_I2c_Stop(); // 
}

u8 CH423_ReadByte() // ȡ
{
	u8 din;
	CH423_I2c_Start(); // 
	CH423_I2c_WrByte( CH423_RD_IO_CMD); // ֵΪ0x4D
	din=CH423_I2c_RdByte(); // ȡ
	CH423_I2c_Stop(); // 
	return (din);
}

void CH423_buf_write(u16 cmd)
{ //CH423ݻ߲Զӳ
	if(cmd & 0x1000)
	{    // ݵ,Ҫݵӳ󻺳
		CH423_buf[(u8) (cmd >> 8) & 0x0F] = (u8) (cmd
                & 0xFF);    // ݵӦӳԪ
    }
    CH423_Write(cmd);    // 
}
void CH423_buf_index(u8 index, u8 dat)
{ // CH423ָ,Զӳ
// index Ϊ,ЧֵΪ015,ֱӦDIG0DIG15
	u16 cmd;
    CH423_buf[index] = dat;    // ݵӦӳԪ
	cmd = ( CH423_DIG0 + ((u16) index << 8)) | dat;    // ɲ
    CH423_Write(cmd);    // 
}
void CH423_set_bit(u8 bit_addr)    // λ
{
	u8 byte_addr;
    byte_addr = (bit_addr >> 3) & 0x0F;
    CH423_buf_index(byte_addr, CH423_buf[byte_addr] | (1 << (bit_addr & 0x07)));
}

void CH423_clr_bit(u8 bit_addr)    // λϨ
{
	u8 byte_addr;
    byte_addr = (bit_addr >> 3) & 0x0F;
	CH423_buf_index(byte_addr,
			CH423_buf[byte_addr] & ~(1 << (bit_addr & 0x07)));
}
void LEFTMOV()    // 
{
	u16 i;
	for(i = 0x000F; i >= 0x0001; i--)
	{
        CH423_buf_index(i, CH423_buf[i - 1]);
    }
    CH423_Write(0x1000);
}

void LEFTCYC()    // ѭ
{
	u16 i, j;
    j = CH423_buf[15];
	for(i = 0x000F; i >= 0x0001; i--)
	{
        CH423_buf_index(i, CH423_buf[i - 1]);
    }
    CH423_Write(0x1000 | j);
}

void RIGHTMOV()    // 
{
	u16 i;
	for(i = 0x0000; i < 0x000F; i++)
	{
        CH423_buf_index(i, CH423_buf[i + 1]);
    }
    CH423_Write(0x1F00);
}

void RIGHTCYC()    // ѭ
{
	u8 i, j;
    j = CH423_buf[0];
	for(i = 0x0000; i < 0x000F; i++)
	{
        CH423_buf_index(i, CH423_buf[i + 1]);
    }
    CH423_Write(0x1F00 | j);
}

void TWINKLE(u8 dig_number)    // ˸
{
	u8 old;
    old = CH423_buf[dig_number & 0x0F];
    CH423_buf_index(dig_number, 0x00);
    rt_thread_mdelay(250);
    CH423_buf_index(dig_number, old);
    rt_thread_mdelay(250);
}




