/*
 * rtc.h
 *
 *  Created on: 202232
 *      Author: Administrator
 */

#ifndef BSP_RTC_RTC_H_
#define BSP_RTC_RTC_H_

struct calendar_obj
{
    u8 hour;
    u8 min;
    u8 sec;

    u16 w_year;
    u8  w_month;
    u8  w_date;
    u8  week;
};
extern struct calendar_obj calendar;

void rtc_exit17_init(void);
u8 RTC_Init(u8 type);
u8 Is_Leap_Year(u16 year);
u8 RTC_Alarm_Set(u16 syear, u8 smon, u8 sday, u8 hour, u8 min, u8 sec);
u8 RTC_Get(void);
u8 RTC_Get_Week(u16 year, u8 month, u8 day);
u8 RTC_Set(u16 syear, u8 smon, u8 sday, u8 hour, u8 min, u8 sec);


#endif /* BSP_RTC_RTC_H_ */
