/*
 * sys.h
 *
 *  Created on: 2023517
 *      Author: Administrator
 */

//CH32V203F8P6=144M64K20K

#ifndef BSP_SYS_SYS_H_
#define BSP_SYS_SYS_H_

#include "ch32v20x.h"
#include "ch32v20x_it.h"

#include "rtc.h"

#include "math.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "stdarg.h"
#include <stdint.h>
#include <stdbool.h>
#include "stk.h"
#include "FLASH.h"
#include "SPI_Flash.h"
#include "HEX_PACK.h"
#include "crc16.h"
#include "cJSON.h"
#include "CH423.h"
#include "rthw.h"
#include "rtthread.h"

//ӵ
#define def_wakeS 10
//ϵͳģʽ

//ADCض
#define def_adc_ch_batv 0
#define def_adc_ch_mti1 1
#define def_adc_ch_mti2 2
//WIBL
#define def_wibl_stak_sleep 0
#define def_wibl_stak_INIT 1
#define def_wibl_stak_9600ATE 2
#define def_wibl_stak_115200ATE 3
#define def_wibl_stak_IMEI 4
#define def_wibl_stak_IMSI 5
#define def_wibl_stak_CREG 6//ѯע
#define def_wibl_stak_QIOPEN 7//򿪵
#define def_wibl_stak_link_lop 8//ά
#define def_wibl_stak_out 100

#define def_wibl_cc_val 3//ش
#define def_wibl_tx_buf_max 500
#define def_wibl_rx_buf_max 500
//
#define def_smg_stak_sleep 0
#define def_smg_stak_init 1
#define def_smg_stak_lop 2
//MT1
#define def_mt1_stak_sleep 0
#define def_mt1_stak_lop 1
//MT2
#define def_mt2_stak_sleep 0
#define def_mt2_stak_lop 1

//GOIPӳ俪ʼ
#define ADCV_SW_Pin            GPIO_Pin_3
#define ADCV_SW_GPIO_Port      GPIOC

#define BATV_CL_Pin            GPIO_Pin_0
#define BATV_CL_GPIO_Port      GPIOA
#define MTI1_CL_Pin            GPIO_Pin_1
#define MTI1_CL_GPIO_Port      GPIOA
#define MTI2_CL_Pin            GPIO_Pin_2
#define MTI2_CL_GPIO_Port      GPIOA

#define MT1_Pin            GPIO_Pin_5
#define MT1_GPIO_Port      GPIOA
#define MT2_Pin            GPIO_Pin_6
#define MT2_GPIO_Port      GPIOA

#define BEEP_Pin            GPIO_Pin_7
#define BEEP_GPIO_Port      GPIOA

#define KEY5_Pin            GPIO_Pin_12
#define KEY5_GPIO_Port      GPIOB
#define KEY4_Pin            GPIO_Pin_13
#define KEY4_GPIO_Port      GPIOB
#define KEY3_Pin            GPIO_Pin_14
#define KEY3_GPIO_Port      GPIOB
#define KEY2_Pin            GPIO_Pin_15
#define KEY2_GPIO_Port      GPIOB
#define KEY1_Pin            GPIO_Pin_6
#define KEY1_GPIO_Port      GPIOC

#define CD_OK_Pin            GPIO_Pin_7
#define CD_OK_GPIO_Port      GPIOC
#define CD_FLG_Pin            GPIO_Pin_8
#define CD_FLG_GPIO_Port      GPIOC
#define USB_IN_Pin            GPIO_Pin_9
#define USB_IN_GPIO_Port      GPIOC

#define WIFI_RST_Pin            GPIO_Pin_8
#define WIFI_RST_GPIO_Port      GPIOA
#define WIFI_RX_Pin            GPIO_Pin_9
#define WIFI_RX_GPIO_Port      GPIOA
#define WIFI_TX_Pin            GPIO_Pin_10
#define WIFI_TX_GPIO_Port      GPIOA
#define WIFI_EN_Pin            GPIO_Pin_11
#define WIFI_EN_GPIO_Port      GPIOA
#define WIFI_SW_Pin            GPIO_Pin_12
#define WIFI_SW_GPIO_Port      GPIOA

#define LED_NET_B_Pin            GPIO_Pin_12
#define LED_NET_B_GPIO_Port      GPIOC
#define LED_NET_G_Pin            GPIO_Pin_2
#define LED_NET_G_GPIO_Port      GPIOD
#define LED_NET_R_Pin            GPIO_Pin_3
#define LED_NET_R_GPIO_Port      GPIOB
#define LED_PWR_B_Pin            GPIO_Pin_4
#define LED_PWR_B_GPIO_Port      GPIOB
#define LED_PWR_G_Pin            GPIO_Pin_5
#define LED_PWR_G_GPIO_Port      GPIOB
#define SMG_SCL_Pin            GPIO_Pin_6
#define SMG_SCL_GPIO_Port      GPIOB
#define SMG_SDA_Pin            GPIO_Pin_7
#define SMG_SDA_GPIO_Port      GPIOB
#define LED_PWR_R_Pin            GPIO_Pin_8
#define LED_PWR_R_GPIO_Port      GPIOB

#define SMGV_SW_Pin            GPIO_Pin_9
#define SMGV_SW_GPIO_Port      GPIOB



//GOIP忪ʼ
#define LED_PWR_R_H GPIO_WriteBit(LED_PWR_R_GPIO_Port,LED_PWR_R_Pin,Bit_SET)
#define LED_PWR_R_L GPIO_WriteBit(LED_PWR_R_GPIO_Port,LED_PWR_R_Pin,Bit_RESET)
#define LED_PWR_G_H GPIO_WriteBit(LED_PWR_G_GPIO_Port,LED_PWR_G_Pin,Bit_SET)
#define LED_PWR_G_L GPIO_WriteBit(LED_PWR_G_GPIO_Port,LED_PWR_G_Pin,Bit_RESET)
#define LED_PWR_B_H GPIO_WriteBit(LED_PWR_B_GPIO_Port,LED_PWR_B_Pin,Bit_SET)
#define LED_PWR_B_L GPIO_WriteBit(LED_PWR_B_GPIO_Port,LED_PWR_B_Pin,Bit_RESET)
#define LED_NET_R_H GPIO_WriteBit(LED_NET_R_GPIO_Port,LED_NET_R_Pin,Bit_SET)
#define LED_NET_R_L GPIO_WriteBit(LED_NET_R_GPIO_Port,LED_NET_R_Pin,Bit_RESET)
#define LED_NET_G_H GPIO_WriteBit(LED_NET_G_GPIO_Port,LED_NET_G_Pin,Bit_SET)
#define LED_NET_G_L GPIO_WriteBit(LED_NET_G_GPIO_Port,LED_NET_G_Pin,Bit_RESET)
#define LED_NET_B_H GPIO_WriteBit(LED_NET_B_GPIO_Port,LED_NET_B_Pin,Bit_SET)
#define LED_NET_B_L GPIO_WriteBit(LED_NET_B_GPIO_Port,LED_NET_B_Pin,Bit_RESET)

#define KEY1_IN GPIO_ReadInputDataBit(KEY1_GPIO_Port,KEY1_Pin)
#define KEY2_IN GPIO_ReadInputDataBit(KEY2_GPIO_Port,KEY2_Pin)
#define KEY3_IN GPIO_ReadInputDataBit(KEY3_GPIO_Port,KEY3_Pin)
#define KEY4_IN GPIO_ReadInputDataBit(KEY4_GPIO_Port,KEY4_Pin)
#define KEY5_IN GPIO_ReadInputDataBit(KEY5_GPIO_Port,KEY5_Pin)

#define USB_IN GPIO_ReadInputDataBit(USB_IN_GPIO_Port,USB_IN_Pin)
#define CD_OK_IN GPIO_ReadInputDataBit(CD_OK_GPIO_Port,CD_OK_Pin)
#define CD_FLG_IN GPIO_ReadInputDataBit(CD_FLG_GPIO_Port,CD_FLG_Pin)

extern struct rt_thread motor1_thread;
extern struct rt_thread motor2_thread;


//ṹ嶨忪ʼ
#pragma pack(1)
struct set_jgt
{
	u32 bl_vr;
	u8 run_mode;
	char *dev_id_str;
	u32 jg_s_cj;
	u32 jg_s_up;
	u32 jg_s_xt;

	u32 mt1_gz_s;
	u32 mt1_jg_h;
	u32 mt2_gz_s;
	u32 mt2_jg_h;
	
	u8 mtx_buf[12];

	char wifi_ssid[25];
	char wifi_pwd[25];
};
#pragma pack()
extern struct set_jgt set_inf;

////#pragma pack(1)
struct bsp_jgt
{
	//
	u32 run_s;
	char *dev_ty_str;
    u32 ap_vr;
	u32 pcb_vr;
    u32 systick_val;
	u32 systick_1s_ms;
	u32 up_ms;
	//// u8 stak;
	u8 err;
	u32 jg_s_cj;
	u32 jg_s_up;
	u32 jg_s_xt;

	//ģʽ
	u8 set_mode_flg;
	u8 set_wei_val;
	
    //IWDG
    u8 iwdg_init_flg;
	//MEM
	rt_uint32_t mem_all;
	rt_uint32_t mem_yon;
	rt_uint32_t mem_yon_max;
    //WAKE
    u8 rtc_wake_flg;
	u8 usb_in_wake_flg;
	//USB-IN
	u8 usb_in_flg;
	//CD-OK
	u8 cd_ok_flg;
	//CD-FLG
	u8 cd_flg_flg;
    //RTC
    u32 rtc_wake_buf;
    u16 rtc_get_nian;
    u8 rtc_get_yue;
    u8 rtc_get_ri;
    u8 rtc_get_shi;
    u8 rtc_get_fen;
    u8 rtc_get_miao;
    u16 rtc_set_nian;
    u8 rtc_set_yue;
    u8 rtc_set_ri;
    u8 rtc_set_shi;
    u8 rtc_set_fen;
    u8 rtc_set_miao;
	//Flash洢
	u8 flash_set_flg;
	//KEY
	u32 key0_dw_ms;
	u32 key1_dw_ms;
	u32 key2_dw_ms;
	u32 key3_dw_ms;
	u32 key4_dw_ms;
	//BEEP
	u32 beep_ms;
    //
    u8 smg_stak;
    u8 smg_stak_run_flg;
	u32 smg_disp_s;
	//ˮ
	u8 mt1_stak;
	u8 mt1_stak_run_flg;
	u32 mt1_gz_s;
	u32 mt1_jg_h;
	u8 mt1_sd_kg;
	u8 mt1_zd_kg;

	u8 mt2_stak;
	u8 mt2_stak_run_flg;
	u32 mt2_gz_s;
	u32 mt2_jg_h;
	u8 mt2_sd_kg;
	u8 mt2_zd_kg;
    //LED-RGB
	u32 led_pwr_r_ms;
	u32 led_pwr_g_ms;
	u32 led_pwr_b_ms;
	u32 led_net_r_ms;
	u32 led_net_g_ms;
	u32 led_net_b_ms;
    //ADC
    s16 adc_adj_val;//*ADCУ׼ֵ
	u16 adc_batv_data;
	float adc_batv_val;
	u16 adc_mti1_data;
	float adc_mti1_val;
	u16 adc_mti2_data;
	float adc_mti2_val;
	//WIBL
	char *wibl_host_dns;
	u16 wibl_host_port;
	char wibl_stak_run_flg;
	u8 wibl_stak;
	u32 wibl_link_get_ms;
	u8 wibl_link_flg;
	char *wibl_tx_type;
	u32 wibl_link_time_out_ms;
	u8 wibl_rx_data;
	u16 wibl_rx_wei;
	u8 wibl_rx_buf[def_wibl_rx_buf_max];
	u16 wibl_tx_wei;
	u8 wibl_tx_buf[def_wibl_tx_buf_max];
	char *wibl_hui0;
	char *wibl_hui1;
	char *wibl_hui2;
	u8 wibl_lop0;
	u8 wibl_imei[30];
	u8 wibl_imsi[30];
	//JSON
	char json_msg_rx_buf[def_wibl_rx_buf_max];
	u16 json_data_run;
	u16 json_data_end;
	char *json_out0;
	char json_out_buf[def_wibl_tx_buf_max];
};
////#pragma pack()
extern struct bsp_jgt sys_inf;

//忪ʼ
void IWDG_Feed_Init(u16 prer, u16 rlr);
void weigou(void);
u8 HSI_SetSysClock(uint32_t pllmul);

void Delay_Ms(u32 time_ms);
void Delay_Nop(u32 time_nop);
void gpio_init_lp(u8 stak);
void beep(u8 stak);
void event_init(u8 stak);
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin);

void smgv_sw(u8 stak);
void mt1_out(u8 stak);
void mt2_out(u8 stak);

void adc_init(u8 stak);
u16 Get_ADC_Val(u8 ch);
u16 Get_ADC_Average(u8 ch, u8 times);
u16 Get_ConversionVal_3_3V(s16 val);
u16 Get_ConversionVal_5V(s16 val);

void wiblv_sw(u8 stak);
void wibl_en(u8 stak);
void wibl_rst(u8 stak);
void wibl_init(u8 stak,u32 btlv);
void wibl_kill(char type);
void wibl_printf(char *fmt,...);
void wibl_send_hex(u8 *data,u16 data_len);
u8 wibl_wait_hui(u32 hui_timeout_ms,u8 hui_cs,char *hui_str0,char *hui_str1,char *hui_str2,char *fmt,...);

u16 byte_ss(char *pk,char str,u16 wei);
char* mystrstr(char* dest,char* src,u16 data_len);
u16 str_copy_run_end(char *mubiao,char *yuan,char run_char,char end_char,u16 len);
char *json_mak(char *data_type); //json
char *json_parse(char *pMsg);

#endif /* BSP_SYS_SYS_H_ */
