################################################################################
# MRS Version: 1.9.1
# ԶɵļҪ༭
################################################################################

# Add inputs and outputs from these tool invocations to the build variables 
C_SRCS += \
../rtthread/libcpu/risc-v/common/cpuport.c 

S_UPPER_SRCS += \
../rtthread/libcpu/risc-v/common/context_gcc.S \
../rtthread/libcpu/risc-v/common/interrupt_gcc.S 

OBJS += \
./rtthread/libcpu/risc-v/common/context_gcc.o \
./rtthread/libcpu/risc-v/common/cpuport.o \
./rtthread/libcpu/risc-v/common/interrupt_gcc.o 

S_UPPER_DEPS += \
./rtthread/libcpu/risc-v/common/context_gcc.d \
./rtthread/libcpu/risc-v/common/interrupt_gcc.d 

C_DEPS += \
./rtthread/libcpu/risc-v/common/cpuport.d 


# Each subdirectory must supply rules for building sources it contributes
rtthread/libcpu/risc-v/common/%.o: ../rtthread/libcpu/risc-v/common/%.S
	@	@	riscv-none-embed-gcc -march=rv32imacxw -mabi=ilp32 -msmall-data-limit=8 -msave-restore -Os -fmessage-length=0 -fsigned-char -ffunction-sections -fdata-sections -fno-common -Wunused -Wuninitialized  -g -x assembler-with-cpp -DCH32V20x_D8W -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\Startup" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\Peripheral\inc" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\include" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\include\libc" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\libcpu" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\libcpu\risc-v\common" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\src" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread" -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@)" -c -o "$@" "$<"
	@	@
rtthread/libcpu/risc-v/common/%.o: ../rtthread/libcpu/risc-v/common/%.c
	@	@	riscv-none-embed-gcc -march=rv32imacxw -mabi=ilp32 -msmall-data-limit=8 -msave-restore -Os -fmessage-length=0 -fsigned-char -ffunction-sections -fdata-sections -fno-common -Wunused -Wuninitialized  -g -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\SPI_Flash" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\CH423" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\CRC" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\DOC" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\FLASH" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\HEX_PACK" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\RTC" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\STK" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\SYS" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\BSP\cJSON" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\Peripheral\inc" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\Core" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\User" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\include" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\include\libc" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\libcpu\risc-v" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\libcpu\risc-v\common" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread\src" -I"D:\EmbeddedSoftware\RF-WTFL230924-EXHM\BL-APP\RF-WTFL230924-EXHM\rtthread" -std=gnu99 -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@)" -c -o "$@" "$<"
	@	@

