/*
 * CH423.h
 *
 *  Created on: 20231024
 *      Author: Administrator
 */


#ifndef BSP_CH423_CH423_H_
#define BSP_CH423_CH423_H_

#include "ch32v20x.h"

//#define SMG_SCL_Pin            GPIO_Pin_15
//#define SMG_SCL_GPIO_Port      GPIOB
//#define SMG_SDA_Pin            GPIO_Pin_15
//#define SMG_SDA_GPIO_Port      GPIOB

#define CH423_SCL_SET GPIO_WriteBit(SMG_SCL_GPIO_Port,SMG_SCL_Pin,Bit_SET)
#define CH423_SCL_CLR GPIO_WriteBit(SMG_SCL_GPIO_Port,SMG_SCL_Pin,Bit_RESET)

#define CH423_SDA_SET GPIO_WriteBit(SMG_SDA_GPIO_Port,SMG_SDA_Pin,Bit_SET)
#define CH423_SDA_CLR GPIO_WriteBit(SMG_SDA_GPIO_Port,SMG_SDA_Pin,Bit_RESET)

#define CH423_SDA_IN GPIO_ReadInputDataBit(SMG_SDA_GPIO_Port,SMG_SDA_Pin)


/* ʱ0.1uSӳ,뵥Ƭٶй,˫I/OԲҪʱ,ڴ׼˫I/Oʱ */
//#define DELAY_0_1US    {}             // MCS51<=10MHz
#define DELAY_0_1US    {asm("nop");}       // MCS51>10MHz

// CH423ӿڶ
#define     CH423_I2C_ADDR1     0x40         // CH423ĵַ
#define     CH423_I2C_MASK      0x3E         // CH423ĸֽ

/*  ϵͳ */
#define CH423_SYSON1    0x0417    //Զɨʾ
#define CH423_SYS_CMD     0x4800     // ϵͳĬϷʽ
#define BIT_X_INT         0x08       // ʹƽ仯жϣΪ0ֹƽ仯жϣΪ1DEC_HΪ0ƽ仯ж
#define BIT_DEC_H         0x04       // ƿ©Ÿ8λƬѡ
#define BIT_DEC_L         0x02       // ƿ©ŵ8λƬѡ
#define BIT_IO_OE         0x01       // ˫ŵ̬Ϊ1

/*  õ8λ© */

#define CH423_OC_L_CMD    0x4400     // õ8λ©ĬϷʽ
#define BIT_OC0_L_DAT     0x01       // OC0Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC1_L_DAT     0x02       // OC1Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC2_L_DAT     0x04       // OC2Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC3_L_DAT     0x08       // OC3Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC4_L_DAT     0x10       // OC4Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC5_L_DAT     0x20       // OC5Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC6_L_DAT     0x40       // OC6Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC7_L_DAT     0x80       // OC7Ϊ0ʹ͵ƽΪ1Ų

/*  ø8λ© */

#define CH423_OC_H_CMD    0x4600      // õ8λ©ĬϷʽ
#define BIT_OC8_L_DAT     0x01        // OC8Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC9_L_DAT     0x02        // OC9Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC10_L_DAT    0x04        // OC10Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC11_L_DAT    0x08        // OC11Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC12_L_DAT    0x10        // OC12Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC13_L_DAT    0x20        // OC13Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC14_L_DAT    0x40        // OC14Ϊ0ʹ͵ƽΪ1Ų
#define BIT_OC15_L_DAT    0x80        // OC15Ϊ0ʹ͵ƽΪ1Ų

/* ˫ */

#define CH423_SET_IO_CMD   0x6000    // ˫ĬϷʽ
#define BIT_IO0_DAT        0x01      // д˫ŵĴIO_OE=1,IO0Ϊ0͵ƽΪ1ߵƽ
#define BIT_IO1_DAT        0x02      // д˫ŵĴIO_OE=1,IO1Ϊ0͵ƽΪ1ߵƽ
#define BIT_IO2_DAT        0x04      // д˫ŵĴIO_OE=1,IO2Ϊ0͵ƽΪ1ߵƽ
#define BIT_IO3_DAT        0x08      // д˫ŵĴIO_OE=1,IO3Ϊ0͵ƽΪ1ߵƽ
#define BIT_IO4_DAT        0x10      // д˫ŵĴIO_OE=1,IO4Ϊ0͵ƽΪ1ߵƽ
#define BIT_IO5_DAT        0x20      // д˫ŵĴIO_OE=1,IO5Ϊ0͵ƽΪ1ߵƽ
#define BIT_IO6_DAT        0x40      // д˫ŵĴIO_OE=1,IO6Ϊ0͵ƽΪ1ߵƽ
#define BIT_IO7_DAT        0x80      // д˫ŵĴIO_OE=1,IO7Ϊ0͵ƽΪ1ߵƽ

/* ȡ˫ */

#define CH423_RD_IO_CMD		0x4D	// I/Oŵǰ״̬

void CH423_SCL_D_OUT(void);
void CH423_SDA_D_OUT(void);
void CH423_SDA_D_IN(void);
// ӳ
extern void CH423_WriteByte(u16 cmd); // д
extern u8 CH423_ReadByte(void); // ȡ

// ض;ӳ
extern void CH423_Write(u16 cmd); // CH423,ӳCH423_WriteByteͬҪǰȽ8λλ
// CH423_WriteӳΪ˼I2CݣǼݣô8λӦ1λ
#define CH423_DIG0      0x1000              // λ0ʾ
#define CH423_DIG1      0x1100              // λ1ʾ
#define CH423_DIG2      0x1200              // λ2ʾ
#define CH423_DIG3      0x1300              // λ3ʾ
#define CH423_DIG4      0x1400              // λ4ʾ
#define CH423_DIG5      0x1500              // λ5ʾ
#define CH423_DIG6      0x1600              // λ6ʾ
#define CH423_DIG7      0x1700              // λ7ʾ
#define CH423_DIG8      0x1800              // λ8ʾ
#define CH423_DIG9      0x1900              // λ9ʾ
#define CH423_DIG10     0x1A00              // λ10ʾ
#define CH423_DIG11     0x1B00              // λ11ʾ
#define CH423_DIG12     0x1C00              // λ12ʾ
#define CH423_DIG13     0x1D00              // λ13ʾ
#define CH423_DIG14     0x1E00              // λ14ʾ
#define CH423_DIG15     0x1F00              // λ15ʾ

void CH423_buf_write(u16 cmd); //CH423ݻ߲Զӳ
void CH423_buf_index(u8 index, u8 dat); // CH423ָ,Զӳ
void CH423_set_bit(u8 bit_addr); // λ
void CH423_clr_bit(u8 bit_addr); // λϨ
void LEFTMOV(void); // 
void LEFTCYC(void); // ѭ
void RIGHTMOV(void); // 
void RIGHTCYC(void); // ѭ
void TWINKLE(u8 dig_number); // ˸


#endif /* BSP_CH423_CH423_H_ */
