/*
 * crc16.c
 *
 *  Created on: 202368
 *      Author: Administrator
 */
//CRCʽ x16+x15+x2+1(0x8005)ݷתLSBCRCĳʼֵΪ0xFFFFֵ0000modbusCRCУ㷨

#include "sys.h"

/* CRC16 ʽ */
static u16 crctalbeabs[]=
{
0x0000,
0xCC01,
0xD801,
0x1400,
0xF001,
0x3C00,
0x2800,
0xE401,
0xA001,
0x6C00,
0x7800,
0xB401,
0x5000,
0x9C01,
0x8801,
0x4400
};

/*!
 *    : CRC16У
 *  param1: ָҪУݵָ
 *  param2: ҪУݵĳ
 *  retval: Уõֵuint16_t 
 *
 *  ˵  : CRCУΪʽΪ x16+x15+x2+1(0x8005)CRCĳʼֵΪ0xFFFF
 */
u16 Crc16(u8 *ptr,u32 len)
{
	u16 crc=0xffff;
	u32 i;
	u8 ch;

	for(i=0;i<len;i++)
	{
		ch=*ptr++;
		crc=crctalbeabs[(ch^crc)&15]^(crc>>4);
		crc=crctalbeabs[((ch>>4)^crc)&15]^(crc>>4);
	}

	return crc;
}

