/*
 * FLASH.c
 *
 *  Created on: 202366
 *      Author: Administrator
 */

#include "sys.h"


u32 flash_read(u32 addr,u8 *rd_data,u32 size)
{
    u32 i=0;
	u32 addr_buf=SET_RUN_ADDR+addr;
    if((addr_buf%2)!=0)
    {//ַ

    }else
    {
		for(i=0;i<size;i++,rd_data++,addr_buf++)
        {
            *rd_data=*(u8 *)addr_buf;
        }
    }
    return i;
}
void flash_erase(long offset, u32 size)
{
	u32 addr= SET_RUN_ADDR+offset;
    u8 erase_pages,i;
    //Ҫҳ
	erase_pages=size/SET_FLASH_SIZE;
	if((size%SET_FLASH_SIZE)!=0)
    {
        erase_pages++;
    }
    u32 page_address=0;
	__disable_irq();
    FLASH_Unlock();
	FLASH_ClearFlag(FLASH_FLAG_BSY|FLASH_FLAG_EOP|FLASH_FLAG_WRPRTERR);
    // һβһ, ִһιֹʱ
    for(i=0;i<erase_pages;i++)
    {
		page_address=addr+(SET_FLASH_SIZE*i);
        FLASH_ErasePage(page_address);
        weigou();
    }
    FLASH_Lock();
	__enable_irq();
}
void flash_write(u32 offset,u8 *wr_data,u32 size)
{
    u32 i=0;
	u32 addr=SET_RUN_ADDR+offset;

	__attribute__((aligned(4)))  uint32_t write_data;
	__attribute__((aligned(4)))  uint32_t read_data;

	if((addr%4)!=0)
    {//ַ

    }else
	{
		////RCC->CFGR0|=(uint32_t)RCC_HPRE_DIV2;

		__disable_irq();
		FLASH_Unlock();

		u32 EraseCounter=0;
		volatile FLASH_Status FLASHStatus=FLASH_COMPLETE;
		u32 NbrOfPage=(SET_END_ADDR-SET_RUN_ADDR)/SET_FLASH_SIZE;
		FLASH_ClearFlag(FLASH_FLAG_BSY|FLASH_FLAG_EOP|FLASH_FLAG_WRPRTERR);
		for(EraseCounter=0;(EraseCounter<NbrOfPage)&&(FLASHStatus==FLASH_COMPLETE);EraseCounter++)
		{
			FLASHStatus=FLASH_ErasePage(SET_RUN_ADDR+(SET_FLASH_SIZE*EraseCounter)); //Erase 4KB
			if(FLASHStatus!=FLASH_COMPLETE)
			{ //ʧ
				sys_inf.led_pwr_r_ms=300;
			}
			//ɹ
			//printf("FLASH Erase Suc\r\n");
		}
		for(i=0;i<size;i+=4,wr_data+=4,addr+=4)
        {
			memcpy(&write_data,wr_data,4); //Ա֤HAL_FLASH_Programwrite_dataڴ׵ַ
			FLASH_ProgramWord(addr,write_data);
			read_data=*(uint32_t *)addr;
            if(read_data!=write_data)
            {//д
				sys_inf.led_pwr_r_ms=300;
            }else
            {//дɹ

            }
            weigou();
        }
        FLASH_Lock();
		////RCC->CFGR0&=~(uint32_t)RCC_HPRE_DIV2;
		__enable_irq();
    }
}


void flash_set_sync(char fangxiang)
{
    u8 data_buf[0xff];
    memset(data_buf,0,0x80);
    if(fangxiang=='w')
    {
        memcpy(&data_buf,&set_inf,sizeof(set_inf));
        flash_write(0,data_buf,0xff);
    }else if(fangxiang=='r')
    {
        flash_read(0,data_buf,0xff);
        memcpy(&set_inf,&data_buf,sizeof(set_inf));
    }
}

