/*
 * FLASH.h
 *
 *  Created on: 202366
 *      Author: Administrator
 */

#ifndef BSP_FLASH_FLASH_H_
#define BSP_FLASH_FLASH_H_

#include "sys.h"

#define APP_RUN_ADDR 0x08000000
#define APP_END_ADDR 0x08000000+(1024*60)


#define SET_RUN_ADDR APP_END_ADDR
#define SET_END_ADDR APP_END_ADDR+SET_FLASH_SIZE
#define SET_FLASH_SIZE  (4*1024)//洢


u32 flash_read(u32 addr,u8 *rd_data,u32 size);
void flash_erase(long offset, u32 size);
void flash_write(u32 offset,u8 *wr_data,u32 size);
void flash_set_sync(char fangxiang);


#endif /* BSP_FLASH_FLASH_H_ */
