/*
 * app_rt_thread.c
 *
 *  Created on: 2023622
 *      Author: Administrator
 */

#include "sys.h"



//WIBL߳---------------------------------------------------------
struct rt_thread wibl_thread;
rt_uint8_t rt_wibl_thread_stack[2048];
void wibl_task_entry(void *parameter);
//SMG߳---------------------------------------------------------
struct rt_thread smg_thread;
rt_uint8_t rt_smg_thread_stack[256];
void smg_task_entry(void *parameter);
//1߳---------------------------------------------------------
struct rt_thread motor1_thread;
rt_uint8_t rt_motor1_thread_stack[256];
void motor1_task_entry(void *parameter);
//2߳---------------------------------------------------------
struct rt_thread motor2_thread;
rt_uint8_t rt_motor2_thread_stack[256];
void motor2_task_entry(void *parameter);




//ʼ̺߳
void RT_Thread_Init(void)
{
	//ʼ߳
	rt_thread_init(&wibl_thread,"wibl",wibl_task_entry,RT_NULL,&rt_wibl_thread_stack[0],sizeof(rt_wibl_thread_stack),3,20);
	rt_thread_startup(&wibl_thread);
	rt_thread_init(&smg_thread,"smg",smg_task_entry,RT_NULL,&rt_smg_thread_stack[0],sizeof(rt_smg_thread_stack),3,20);
	rt_thread_startup(&smg_thread);
	rt_thread_init(&motor1_thread,"motor1",motor1_task_entry,RT_NULL,&rt_motor1_thread_stack[0],sizeof(rt_motor1_thread_stack),3,20);
	rt_thread_startup(&motor1_thread);
	rt_thread_init(&motor2_thread,"motor2",motor2_task_entry,RT_NULL,&rt_motor2_thread_stack[0],sizeof(rt_motor2_thread_stack),3,20);
	rt_thread_startup(&motor2_thread);
}
//
void RT_Thread_Process(void)
{
	gpio_init_lp(1);
	event_init(1);
	if(1)
	{
		if(RTC_Init(1)==1)
		{ //ⲿʧ=ڲ
			RTC_Init(0);
		}
		rtc_exit17_init();
		RTC_SetAlarm(RTC_GetCounter()+def_wakeS);
	}
	RT_Thread_Init();
	if(1)
	{
		sys_inf.led_pwr_r_ms=sys_inf.led_net_r_ms=1000; ////
		sys_inf.beep_ms=500;
		rt_thread_mdelay(1100);
		sys_inf.led_pwr_g_ms=sys_inf.led_net_g_ms=1000;
		sys_inf.beep_ms=500;
		rt_thread_mdelay(1100);
		sys_inf.led_pwr_b_ms=sys_inf.led_net_b_ms=1000;
		sys_inf.beep_ms=500;
		rt_thread_mdelay(1100);
	}
	if(1)
	{ //һ
		sys_inf.jg_s_cj=set_inf.jg_s_cj; //
		sys_inf.jg_s_up=set_inf.jg_s_up; //
		sys_inf.jg_s_xt=set_inf.jg_s_xt; //
	}
	while(1)
	{
		rt_thread_mdelay(50);
		weigou();
		if(0)//((sys_inf.usb_in_flg)||(sys_inf.mt1_stak_run_flg)||(sys_inf.mt2_stak_run_flg)||(sys_inf.smg_stak_run_flg)||(sys_inf.wibl_stak_run_flg))
		{ //USBûӡû̻߳=
			gpio_init_lp(0);
			RTC_SetAlarm(RTC_GetCounter()-1+def_wakeS);
			RTC_WaitForLastTask();
			PWR_EnterSTOPMode(PWR_Regulator_LowPower, PWR_STOPEntry_WFI);
			//---------------------߷ֽ------------------------------
			SystemInit();
		}
		if(sys_inf.rtc_wake_flg==1)
		{ //RTCжϻ
			sys_inf.rtc_wake_flg=0;

			Systick_Init();
			RTC_SetAlarm(RTC_GetCounter()-1+def_wakeS);
			RTC_WaitForLastTask();
		}
		if(1)
		{ //
			
		}
		if(0)//(sys_inf.flash_set_flg==1)
		{ //洢
			sys_inf.flash_set_flg=0;
			flash_set_sync('w');

		}
		if(sys_inf.jg_s_cj>=set_inf.jg_s_cj)
		{ //ɼʱ䵽
			sys_inf.jg_s_cj=0;

		}

		if(sys_inf.jg_s_up>=set_inf.jg_s_up)
		{ //ϱʱ䵽
			sys_inf.jg_s_up=0;
			sys_inf.wibl_tx_type="up_data";
			if(sys_inf.wibl_stak_run_flg==0)
			{
				rt_thread_resume(&wibl_thread);
			}
		}
		if(sys_inf.jg_s_xt>=set_inf.jg_s_xt)
		{ //ʱ䵽
			sys_inf.jg_s_xt=0;

		}
		if(1)
		{ //ûϱ

		}
	}
}

//WIBL
void wibl_task_entry(void *parameter)
{
	sys_inf.wibl_stak_run_flg=1;

	while(1)
	{
		rt_thread_mdelay(50);
		switch(sys_inf.wibl_stak)
		{
			case def_wibl_stak_sleep: //
				wibl_init(0,9600);
				wibl_rst(0);
				sys_inf.wibl_stak_run_flg=0;
				rt_thread_suspend(&wibl_thread);
				rt_schedule();
				sys_inf.wibl_stak_run_flg=1;
				sys_inf.wibl_stak=def_wibl_stak_INIT;
				break;
	
				case def_wibl_stak_INIT://ʼ
				wibl_init(0,9600);
				wibl_init(1,9600);
				wibl_rst(1);
				rt_thread_mdelay(200);
				wibl_rst(0);
				sys_inf.wibl_stak=def_wibl_stak_9600ATE;
			break;

			case def_wibl_stak_9600ATE://9600
				if(wibl_wait_hui(1000,60,"OK","OK","ok","ATE0\r\n")==0)
				{ //ɹ
					sys_inf.wibl_stak=def_wibl_stak_IMEI;
				} else
				{ //ʧ
					sys_inf.wibl_stak=def_wibl_stak_115200ATE;
					wibl_init(1,115200);
				}
			break;

			case def_wibl_stak_115200ATE: //115200
				if(wibl_wait_hui(1000,60,"OK","OK","OK","ATE0\r\n")==0)
				{ //ɹ
					sys_inf.wibl_stak=def_wibl_stak_IMEI;
				} else
				{ //ʧ
					sys_inf.wibl_stak=def_wibl_stak_out;
					wibl_init(1,9600);
				}
			break;

			case def_wibl_stak_IMEI: //ѯIMEI
				if(wibl_wait_hui(500,20,"OK","OK","OK","AT+CGSN\r\n")==0)
				{ //ɹ
					sys_inf.wibl_stak=def_wibl_stak_IMSI;
	
					memset(sys_inf.wibl_imei,0,30);
					strncpy(sys_inf.wibl_imei,sys_inf.wibl_rx_buf+2,15);
				} else
				{ //ʧ
					sys_inf.wibl_stak=def_wibl_stak_out;
				}
			break;

			case def_wibl_stak_IMSI: //ѯIMSI
				if(wibl_wait_hui(500,20,"OK","OK","OK","AT+CIMI\r\n")==0)
				{ //ɹ
					sys_inf.wibl_stak=def_wibl_stak_CREG;
	
					memset(sys_inf.wibl_imsi,0,30);
					strncpy(sys_inf.wibl_imsi,sys_inf.wibl_rx_buf+2,15);
				}
				else
				{ //ʧ
					sys_inf.wibl_stak=def_wibl_stak_out;
				}
			break;

			case def_wibl_stak_CREG: //鿴ע
				if(wibl_wait_hui(500,20,"+CGREG: 0,1","+CGREG: 0,5","OK","AT+CGREG?\r\n")==0)
				{ //ɹ
					sys_inf.wibl_stak=def_wibl_stak_QIOPEN;
				} else
				{ //ʧ
					sys_inf.wibl_stak=def_wibl_stak_out;
				}
			break;

			case def_wibl_stak_QIOPEN: //ӵ
				if(wibl_wait_hui(3000,5,"+QIOPEN: 0,0","CONNECT OK","ALREADY CONNECT","AT+CIPSTART=\"TCP\",\"%s\",%d\r\n",sys_inf.wibl_host_dns,sys_inf.wibl_host_port)==0)
				{ //ӵɹ
					sys_inf.wibl_stak=def_wibl_stak_link_lop;
					sys_inf.wibl_link_time_out_ms=0;
					sys_inf.wibl_link_flg=1;
				} else
				{ //ʧ
					sys_inf.wibl_stak=def_wibl_stak_out;
				}
			break;

			case def_wibl_stak_link_lop: //
			rt_thread_mdelay(50);
				if(sys_inf.wibl_rx_wei>0)
				{ //
					rt_thread_mdelay(200);
					if(str_copy_run_end(sys_inf.json_msg_rx_buf,sys_inf.wibl_rx_buf,'{','}',0xff-1)>2)
					{ //JSON
						sys_inf.wibl_hui0=json_parse(sys_inf.json_msg_rx_buf);
						if(strnstr(sys_inf.wibl_hui0,"get_inf",0xff)!=NULL)
						{ //ȡϢ
							sys_inf.led_net_r_ms=100;
						}
					} else
					{ //Ϣ
						if(strstr(sys_inf.wibl_rx_buf,"STATE: CONNECT OK")!=NULL)
						{ //
							sys_inf.wibl_link_flg=1;
						} else if((strstr(sys_inf.wibl_rx_buf,"+E_UTRAN Service")!=NULL)&&(strstr(sys_inf.wibl_rx_buf,"+CGEV: ME PDN ACT")!=NULL))
						{ //
							sys_inf.wibl_stak=def_wibl_stak_CREG;
							sys_inf.wibl_link_flg=0;
							wibl_kill('t');wibl_kill('r');
						} else if(strstr(sys_inf.wibl_rx_buf,"STATE: IP INITIAL")!=NULL)
						{ //
							sys_inf.wibl_stak=def_wibl_stak_QIOPEN;
							sys_inf.wibl_link_flg=0;
						} else if(strstr(sys_inf.wibl_rx_buf,"STATE: PDP DEACT")!=NULL)
						{ //
							sys_inf.wibl_stak=def_wibl_stak_INIT;
							sys_inf.wibl_link_flg=0;
						} else if(strstr(sys_inf.wibl_rx_buf,"CLOSED")!=NULL)
						{ //ӹرCLOSED
							sys_inf.wibl_stak=def_wibl_stak_out;
							sys_inf.wibl_link_flg=0;
						}
					}
					wibl_kill('t');wibl_kill('r');
				} else if(sys_inf.wibl_link_get_ms>=(1000*10))
				{ //ѯCAT1״̬
					sys_inf.wibl_link_get_ms=0;
					wibl_printf("AT+CIPSTATUS\r\n");
				} else if(sys_inf.wibl_tx_type!=NULL)
				{ //
					if(wibl_wait_hui(500,5,">",">",">","AT+CIPSEND\r\n")==0)
					{
						sys_inf.wibl_link_flg=1;
						sys_inf.wibl_link_time_out_ms=0;
						rt_thread_mdelay(500);
						wibl_printf("%s",json_mak(sys_inf.wibl_tx_type));
						rt_thread_mdelay(100);
						sys_inf.wibl_tx_buf[0]=0x1A;
						wibl_send_hex(sys_inf.wibl_tx_buf,1);
						wibl_kill('t');wibl_kill('r');
						sys_inf.wibl_tx_type=NULL;
					}
				}
			break;

			case def_wibl_stak_out:
				sys_inf.wibl_stak=def_wibl_stak_sleep;
			break;

			default :
				sys_inf.wibl_stak=def_wibl_stak_sleep;
			break;
		}

	}
}
//SMG
void smg_task_entry(void *parameter)
{
	while(1)
	{
		rt_thread_mdelay(100);
        switch (sys_inf.smg_stak)
        {
			case def_smg_stak_sleep: //
				sys_inf.smg_stak_run_flg=0;
				smgv_sw(0);
				rt_thread_suspend(&smg_thread);
				rt_schedule();
				sys_inf.smg_stak_run_flg=1;
				smgv_sw(1);
				sys_inf.smg_stak=def_smg_stak_init;
			break;

            case def_smg_stak_init://ʼ
            	
            	sys_inf.smg_stak=def_smg_stak_lop;
            break;

            case def_smg_stak_lop://ѭ
				while(sys_inf.smg_disp_s)
				{
					rt_thread_mdelay(100);
					if(sys_inf.set_mode_flg==1)
					{//ģʽ
						//˸
						TWINKLE(sys_inf.set_wei_val);
						//ùʱʾ
						CH423_buf_index(0,set_inf.mtx_buf[0]);
						CH423_buf_index(1,set_inf.mtx_buf[1]);
						CH423_buf_index(2,set_inf.mtx_buf[2]);
						//üʱʾ
						CH423_buf_index(6,set_inf.mtx_buf[3]);
						CH423_buf_index(7,set_inf.mtx_buf[4]);
						CH423_buf_index(8,set_inf.mtx_buf[5]);
						//ұùʱʾ
						CH423_buf_index(3,set_inf.mtx_buf[6]);
						CH423_buf_index(4,set_inf.mtx_buf[7]);
						CH423_buf_index(5,set_inf.mtx_buf[8]);
						//ұüʱʾ
						CH423_buf_index(9,set_inf.mtx_buf[9]);
						CH423_buf_index(10,set_inf.mtx_buf[10]);
						CH423_buf_index(11,set_inf.mtx_buf[11]);
					}else
					{//ڹģʽ
						//ùʱʾ
						CH423_buf_index(0,sys_inf.mt1_gz_s/100);
						CH423_buf_index(1,(sys_inf.mt1_gz_s%100)/10);
						CH423_buf_index(2,(sys_inf.mt1_gz_s%100)%10);
						//üʱʾ
						CH423_buf_index(6,sys_inf.mt1_jg_h/100);
						CH423_buf_index(7,(sys_inf.mt1_jg_h%100)/10);
						CH423_buf_index(8,(sys_inf.mt1_jg_h%100)%10);
						//ұùʱʾ
						CH423_buf_index(3,sys_inf.mt2_gz_s/100);
						CH423_buf_index(4,(sys_inf.mt2_gz_s%100)/10);
						CH423_buf_index(5,(sys_inf.mt2_gz_s%100)%10);
						//ұüʱʾ
						CH423_buf_index(9,sys_inf.mt2_jg_h/100);
						CH423_buf_index(10,(sys_inf.mt2_jg_h%100)/10);
						CH423_buf_index(11,(sys_inf.mt2_jg_h%100)%10);
					}					
				}
				sys_inf.smg_stak=def_smg_stak_sleep;
            break;

			default:
			sys_inf.smg_stak=def_smg_stak_sleep;
            break;
        }
	}
}
//MoTor1
void motor1_task_entry(void *parameter)
{
	while(1)
	{
		rt_thread_mdelay(100);
		switch (sys_inf.mt1_stak)
		{
			case def_mt1_stak_sleep: //
			mt1_out(0);
			sys_inf.mt1_stak_run_flg=0;
			rt_thread_suspend(&motor1_thread);
			rt_schedule();
			sys_inf.mt1_stak_run_flg=1;
			sys_inf.mt1_stak=def_mt1_stak_lop;
			break;

			case def_mt1_stak_lop://
			while((sys_inf.mt1_zd_kg==1)||(sys_inf.mt1_sd_kg==1))
			{ //Զػֶ
				rt_thread_mdelay(100);
				mt1_out(1);
			}
			sys_inf.mt1_sd_kg=0; //λֶ
			sys_inf.mt1_stak=def_mt1_stak_sleep;
			break;

			default:
			sys_inf.mt1_stak=def_mt1_stak_sleep;
			break;
		}
	}
}
//MoTor2
void motor2_task_entry(void *parameter)
{
	while(1)
	{
		rt_thread_mdelay(100);
		switch (sys_inf.mt2_stak)
		{
			case def_mt2_stak_sleep: //
			mt2_out(0);
			sys_inf.mt2_stak_run_flg=0;
			rt_thread_suspend(&motor2_thread);
			rt_schedule();
			sys_inf.mt2_stak_run_flg=1;
			sys_inf.mt2_stak=def_mt2_stak_lop;
			break;

			case def_mt2_stak_lop://
			while((sys_inf.mt2_zd_kg==1)||(sys_inf.mt2_sd_kg==1))
			{ //Զػֶ
				rt_thread_mdelay(100);
				mt2_out(1);
			}
			sys_inf.mt2_sd_kg=0; //λֶ
			sys_inf.mt2_stak=def_mt2_stak_sleep;
			break;

			default:
			sys_inf.mt2_stak=def_mt2_stak_sleep;
			break;
		}
	}
}

































